#ren'py本体にはマウスの位置を操作する機能がないようなので追加した
#windowでしかテストしていないので他の環境で問題が発生したら教えておくれ

#ren'py(というよりpygame?)は大きさを変えても、FullScreenにしても
#黒枠の存在も無視して画面左上からのピクセル位置で考えるので
#無理矢理計算した、たぶん大丈夫

#使える関数
#automouse_jump(x, y)
#(x,y)に瞬間移動
#automouse_move(x, y, time_ms)
#(x,y)にtime_ms秒かけて移動
#automouse_get_pos() return (x, y)
#マウス位置を所得
#(大きさを変えても、フルスクリーンにしても最初のウィンドウモードでの位置に直して返す)

#使えるAction
#MouseMove(x, y, time_ms)
#(x,y)にtime_ms秒かけて移動
#MouseJump(x, y)
#(x,y)に瞬間移動

#各関数、Actionは変数persistent.automouseが偽ならなにもしない
#x,yは画面左上からの相対px座標
init -1 python:
    import pygame
    # デフォルトでは真, 初回起動時のみ実行
    if persistent.automouse is None:
        persistent.automouse = True

    # def automouse_yesno_prompt(*args):
    #     automouse_move(250, 150, 100)
    #     return yesno_prompt_org(*args)

    def automouse_jump(x, y):
        if not persistent.automouse:
            return
        x, y = automouse_windowmode_pos_to_true_pos(x, y)
        pygame.mouse.set_pos([x, y])

    def automouse_move(goalx, goaly, time_ms):
        if not persistent.automouse:
            return
        goalx, goaly = automouse_windowmode_pos_to_true_pos(goalx, goaly)
        starttime = pygame.time.get_ticks()
        startx, starty = pygame.mouse.get_pos()
        speedx = ( float(goalx - startx) / float(time_ms) )
        speedy = ( float(goaly - starty) / float(time_ms) )
        while(1):
            nowtime = pygame.time.get_ticks()
            pygame.mouse.set_pos([speedx*(nowtime-starttime)+startx, speedy*(nowtime-starttime)+starty])
            if nowtime - starttime >= time_ms:
                break

    def automouse_get_pos():
        x, y = pygame.mouse.get_pos()
        return automouse_true_pos_to_windowmode_pos(x, y)

    def automouse_blackline_pos():
        videoinfo = pygame.display.Info()
        now_w = float(videoinfo.current_w)
        now_h = float(videoinfo.current_h)
        def_w = float(config.screen_width)
        def_h = float(config.screen_height)
        if now_w * (def_h / def_w) <= now_h:
            return (0, int(( now_h -  now_w * (def_h / def_w) ) / 2))
        else:
            return (int(( now_w -  now_h * (def_w / def_h) ) / 2), 0)

    def automouse_windowmode_pos_to_true_pos(x, y):
        videoinfo = pygame.display.Info()
        x = float(x)
        y = float(y)
        now_w = float(videoinfo.current_w)
        now_h = float(videoinfo.current_h)
        def_w = float(config.screen_width)
        def_h = float(config.screen_height)

        bl_x, bl_y = automouse_blackline_pos()
        bl_x = float(bl_x)
        bl_y = float(bl_y)
        X = x * (now_w - 2*bl_x) / def_w
        Y = y * (now_h - 2*bl_y) / def_h
        return (int(X + bl_x), int(Y + bl_y))

    def automouse_true_pos_to_windowmode_pos(x, y):
        videoinfo = pygame.display.Info()
        now_w = float(videoinfo.current_w)
        now_h = float(videoinfo.current_h)
        def_w = float(config.screen_width)
        def_h = float(config.screen_height)

        bl_x, bl_y = automouse_blackline_pos()
        bl_x = float(bl_x)
        bl_y = float(bl_y)

        X = (float(x) - bl_x) * def_w / (now_w - 2*bl_x)
        Y = (float(y) - bl_y) * def_h / (now_h - 2*bl_y)
        return (int(X), int(Y))

    # Actionを生成
    class MouseMove(Action):
        def __init__(self, x, y, time):
            self.x = x
            self.y = y
            self.time = time
        def __call__(self):
            automouse_move(self.x, self.y, self.time)

    class MouseJump(Action):
        def __init__(self, x, y):
            self.x = x
            self.y = y
        def __call__(self):
            automouse_jump(self.x, self.y)
    # yesno_prompt_org = layout.yesno_prompt
    # layout.yesno_prompt = automouse_yesno_prompt
